## Define methods for summary generic function
##
## Gustavo H. Esteves
## 10/05/07
##
##


## For maigesPreRaw class
summary.maigesPreRaw <- function(object, ...)
    print(object)


## For maigesRaw class
summary.maigesRaw <- function(object, ...)
    print(object)


## For maiges class
summary.maiges <- function(object, ...)
    print(object)


## For maigesANOVA class
summary.maigesANOVA <- function(object, ...)
    print(object)


## For maigesDE class
summary.maigesDE <- function(object, ...) {

    cat(paste("\nObject of class ", class(object), " generated by ",
    object@Date, ", \n using ", object@V.info$R.version, ".\n\n", sep=""))

    if(dim(object@p.value)[1] >= 10) {
        idx <- sort(object@p.value[, 1], index.return=TRUE)$ix[1:10]
        tmp <- data.frame(Gene.index=idx, Statistic=object@stat[idx, 1],
        P.value=object@p.value[idx, 1])

        cat(paste("\nThe 10 most DE (using", object@test,
        "method) genes in the first test are:\n\n"))

        print(tmp)
        cat("\n")
    }
    else {
        idx <- sort(object@p.value[, 1], index.return=TRUE)$ix
        tmp <- data.frame(Gene.index=idx, Statistic=object@stat[idx, 1],
        P.value=object@p.value[idx, 1])

        cat(paste("\nThere are(is) only", dim(object@p.value)[1],
        "gene(s) in this object, ordering by p-values,\n",
        "the DE (using", object@test,
        "method) genes in the first test are:\n\n"))

        print(tmp)
        cat("\n")
    }
}


## For maigesDEcluster class
summary.maigesDEcluster <- summary.maigesDE


## For maigesClass class
summary.maigesClass <- function(object, ...) {

    cat(paste("\nObject of class ", class(object), " generated by ",
    object@Date, ", \n using ", object@V.info$R.version, ".\n\n", sep=""))

    cat(paste(dim(object@cliques)[1], "classifiers - by method", object@method,
    "\n of", dim(object@cliques)[2], "genes, ordered by CV value.\n"))

    cat("The 10 classifiers with greater CV are:\n")

    if(length(object@cliques[,1]) > 10) {
        tmp <- data.frame(object@cliques[1:10, ], object@CV[1:10])
        print(tmp)
    }
    else {
        tmp <- data.frame(object@cliques, object@CV)
        print(tmp)
    }

    cat("\n\n")

}


## For maigesRelNetM class
summary.maigesRelNetM <- function(object, ...) {

    cat(paste("\nObject of class", class(object), "generated by",
    object@Date, ", using", object@V.info$R.version, "\n\n"))

    cat(paste("Relevance network analysis for a group of ",
    dim(object@Corr1)[1], " genes, for types ", paste(object@types,
    collapse=" and "), " from sample label ", object@Slabel, ".\n\n", sep=""))

}


## For maigesRelNetB class
summary.maigesRelNetB <- function(object, ...) {

    cat(paste("\nObject of class", class(object), "generated by",
    object@Date, ", using", object@V.info$R.version, "\n\n"))

    cat(paste("Relevance network analysis for a group of ", dim(object@Corr)[1],
    " genes, for type ", object@type, " from sample label ", object@Slabel,
    ".\n\n", sep=""))

}


## For maigesActMod class
summary.maigesActMod <- function(object, ...) {

    cat(paste("\nObject of class ", class(object), " generated by ",
    object@Date, ", \n using ", object@V.info$R.version, ".\n\n", sep=""))
    cat(paste("Active module analysis.\n"))

    cat(paste("\nGene groups used were:\n"))
    print(colnames(object@modByCond))

    cat(paste("\nBiological samples used were:\n"))
    print(rownames(object@modByCond))

    cat("\n\n")

}


## For maigesActNet class
summary.maigesActNet <- function(object, ...) {

    cat(paste("\nObject of class ", class(object), " generated by ",
    object@Date, ", \n using ", object@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Functional classification of gene regulatory networks.\n"))

    cat(paste("\nGene networks used were:\n"))
    print(colnames(object@scores))

    cat(paste("\nBiological samples used were:\n"))
    print(rownames(object@scores))

    cat("\n\n")

}
